unit hiSPI;

interface

uses Kol,Share,Windows,Debug;

type
  THISPI = class(TDebug)
   private
   Nb:integer;  
  LCPHA0,MCPHA0,LCPHA1,MCPHA1:byte;// //     
   
   public
          
	_event_onLCPHA0_MOSI:THI_Event;
	_event_onMCPHA0_MOSI:THI_Event;
	_event_onLCPHA1_MOSI:THI_Event;
	_event_onMCPHA1_MOSI:THI_Event;
	_event_onMCPHA0:THI_Event;
    _event_onLCPHA0:THI_Event;
    _event_onMCPHA1:THI_Event;
    _event_onLCPHA1:THI_Event;
	_event_onCPOL0:THI_Event;
    _event_onCPOL1:THI_Event;
   	_event_onLatch:THI_Event; //    595
	_event_onLoad:THI_Event; //    165
		     
    _data_DataSPI:THI_Event; //     SPI
    _data_DataMISO:THI_Event; //     MISO
            
    procedure _work_doSendSPI(var _Data:TData; Index:word);
    
	procedure _var_LCPHA0(var _Data:TData; Index:word);	    //      
    procedure _var_MCPHA0(var _Data:TData; Index:word);     // 
    procedure _var_LCPHA1(var _Data:TData; Index:word);	    //      
    procedure _var_MCPHA1(var _Data:TData; Index:word);     // 
	
		
	property _prop_NbitMISO:integer write Nb;//      
 
  end;

implementation

procedure THISPI._work_doSendSPI;

var
i:integer;
MISO,MOSI:byte;//

begin
MOSI := ReadInteger(_Data,_data_DataSPI); 

//=====   165 =======
_hi_onEvent(_event_onLoad, 0);
_hi_onEvent(_event_onLoad, 1);
//=============================

_hi_onEvent(_event_onCPOL0, 0);
_hi_onEvent(_event_onCPOL1, 1);

       
	   for i := 0 to 7 do  //    
           begin 
////////////// CPHA=0 /////////////////////////////////////////////////
//============  ==================================================
          MISO := ReadInteger(_Data,_data_DataMISO);
		  //   
		 if MISO and (1 shl Nb) <> 0 then LCPHA0 := LCPHA0 or (1 shl i); //   0
         if MISO and (1 shl Nb) = 0 then LCPHA0 := LCPHA0 and not (1 shl i); //   1
		 //   
         if MISO and (1 shl Nb) <> 0 then MCPHA0 := MCPHA0 or (1 shl (7-i));
         if MISO and (1 shl Nb) = 0 then MCPHA0 := MCPHA0 and not (1 shl (7-i));
//=============  =====================================================		 
		 //   
		 if MOSI and (1 shl i) <> 0 then _hi_onEvent(_event_onLCPHA0_MOSI, 1);
         if MOSI and (1 shl i) = 0 then _hi_onEvent(_event_onLCPHA0_MOSI, 0);
		 //   
         if MOSI and (1 shl (7-i)) <> 0 then _hi_onEvent(_event_onMCPHA0_MOSI, 1);
         if MOSI and (1 shl (7-i)) = 0 then _hi_onEvent(_event_onMCPHA0_MOSI, 0);	       
//===========================================================================		   
		 		   
		 _hi_onEvent(_event_onCPOL0, 1);
		 _hi_onEvent(_event_onCPOL1, 0);
		 
 ////////////// CPHA=1 /////////////////////////////////////////////////
//============  ==================================================
          MISO := ReadInteger(_Data,_data_DataMISO);
		  //   
		 if MISO and (1 shl Nb) <> 0 then LCPHA1 := LCPHA1 or (1 shl i);
         if MISO and (1 shl Nb) = 0 then LCPHA1 := LCPHA1 and not (1 shl i);
		 //   
         if MISO and (1 shl Nb) <> 0 then MCPHA1 := MCPHA1 or (1 shl (7-i));
         if MISO and (1 shl Nb) = 0 then MCPHA1 := MCPHA1 and not (1 shl (7-i));
//=============  =====================================================		 
		 //   
		 if MOSI and (1 shl i) <> 0 then _hi_onEvent(_event_onLCPHA1_MOSI, 1);
         if MOSI and (1 shl i) = 0 then _hi_onEvent(_event_onLCPHA1_MOSI, 0);
		 //   
         if MOSI and (1 shl (7-i)) <> 0 then _hi_onEvent(_event_onMCPHA1_MOSI, 1);
         if MOSI and (1 shl (7-i)) = 0 then _hi_onEvent(_event_onMCPHA1_MOSI, 0);	       
//===========================================================================		   
         
		 _hi_onEvent(_event_onCPOL0, 0);
		 _hi_onEvent(_event_onCPOL1, 1);

			end;

//=====   595 =======
_hi_onEvent(_event_onLatch, 0);
_hi_onEvent(_event_onLatch, 1);
//=============================
_hi_onEvent(_event_onLCPHA0, LCPHA0);
_hi_onEvent(_event_onMCPHA0, MCPHA0);
_hi_onEvent(_event_onLCPHA1, LCPHA1);
_hi_onEvent(_event_onMCPHA1, MCPHA1);
end;
procedure THISPI._var_LCPHA0;      //
begin dtInteger(_Data,LCPHA0);end;    //
procedure THISPI._var_MCPHA0;      //
begin dtInteger(_Data,MCPHA0);end;    //
procedure THISPI._var_LCPHA1;      //
begin dtInteger(_Data,LCPHA1);end;    //
procedure THISPI._var_MCPHA1;      //
begin dtInteger(_Data,MCPHA1);end;    //
end.
